<?php

/*
Mailboy - A Php/MySQL application that offers a web based interface
to administer an email server. It can be used by the server administrator
as well as the email users.
(c) 2009 Emmanuel Revah - manu-at-manurevah.com
http://manurevah.com/blah/en/pages/mailboy

This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/

$domain_id = $_GET[domain_id];
if (am_i_admin_of($domain_id) OR am_i_server_admin(1)) {
	if (is_numeric($domain_id)) {
		/* policy query for edit domain and add account */
		$policyq = mysql_query("SELECT * FROM policy;");
		while ($data = mysql_fetch_assoc($policyq)) {
			$policy_id = $data[id];
			$policies[$policy_id] = $data[policy_name];
		}
		/* current domain */
		function current_domain($domain_id) {
			$current_domain_q = mysql_query("SELECT * FROM view_domains WHERE id = $domain_id;");
			while ($data = mysql_fetch_assoc($current_domain_q)) {
				foreach ($data as $k => $v) {
					if ($k == "default_quota") {
						$v = $v / 1024;
					}
					$domain[$k] = $v;
				}
			}
			return $domain;
		}
		$content[domain] = current_domain($domain_id);
		$cur_domain = $content[domain][name];

		/* EDIT DOMAIN */
		if ($_POST[edit_domain]) {
			if (am_i_admin_of($domain_id)) {
			//if (am_i_server_admin()) {
				if ($_POST[mod_domain_confirm]) {
					$update_mysql_query = "UPDATE virtual_domains SET";
					if (!empty($_POST[new_domain])) {
						if ($_POST[new_domain] != $cur_domain) {
							$content[status][] = "cur $cur_domain";
							if (am_i_server_admin(2)) {
								$new_domain = strtolower($_POST[new_domain]);
								/* check if domain contains illegal crap */
								if (preg_match_all("$reg_domain", $new_domain, $matches)) {
									$content[errors][] = "Domain name contains unauthorized characters";
									$new_domain = str_replace($matches[0], "", "$new_domain");
								}
								$update_mysql_query .= " `name` = '$new_domain',";
							} else {
								$content[errors][] = "You must be server admin to change the domain name";
							}
						}
					} else {
						$content[errors][] = "Domain name is empty";
					}
					if (!array_key_exists($_POST[policy], $policies) AND !empty($_POST[policy])) {
						$content[errors][] = "Bad policy id";
					} else {
						$update_mysql_query .= " `default_policy` = '$_POST[policy]',";
					}
					if (isset($_POST[default_quota])) {
						if (is_numeric($_POST[default_quota])) {
							$default_quota = $_POST[default_quota] * 1024;
							$update_mysql_query .= " `default_quota_kb` = '$default_quota'";
						} else {
							$content[status][] = "Quota is not numeric so it's unchanged";
						}
					}
					if (empty($content[errors])) {
						$update_mysql_query = rtrim($update_mysql_query, ",");
						$update_mysql_query .= " WHERE id = $domain_id;";
						mysql_query("$update_mysql_query");
						if (!mysql_error()) {
							$content[status][] = "Domain <strong>$new_domain</strong> modified \o/";
							// refresh domain array
							$content[domain] = current_domain($domain_id);
							$cur_domain = $content[domain][name];
						} else {
							$content[errors][] = mysql_error();
						}
					} else {
						$content[status][] = "Domain not modified";
					}
				} else {
					$content[errors][] = "You should check the confirm box if you are sure about this";
				}
			} else {
				$content[errors][] = "You must be server administrator to modify $cur_domain";
			}
		}
		$content[forms][mod_domain][policy] = "policy";
		$content[forms][mod_domain][policies] = $policies;
		$content[forms][mod_domain][default_quota] = "default_quota";
		$content[forms][mod_domain][new_domain] = "new_domain";
		$content[forms][mod_domain][mod_domain_confirm] = "mod_domain_confirm";
		$content[forms][mod_domain][submit] = "edit_domain";

		/* DELETE ACCOUNT */
		$content[forms][del_account][submit] = "submit_del_account";
		$content[forms][del_account][del_account] = "del_account";
		$content[forms][del_account][del_account_confirm] = "del_account_confirm";
		/* deal with post [del_account] */
		if ($_POST[submit_del_account]) {
			if (am_i_admin_of($domain_id)) {
				if ($_POST[del_account] AND $_POST[del_account_confirm]) {
					foreach ($_POST[del_account] as $k => $v) {
						$get_email = mysql_query("SELECT email, admin FROM view_users WHERE uid = $v;");
						$delled_email = mysql_fetch_assoc($get_email);
						$deleted_email = $delled_email[email];
						if (($delled_email[admin] != 1 OR am_i_super_admin()) AND ($v != $super_dooper_user))  {
							if (!empty($deleted_email)) {
								$del_q =mysql_query("DELETE FROM `virtual_users` WHERE `virtual_users`.`id` = $v;");
								if (!mysql_error()) {
									$content[status][] = "Account <strong>$deleted_email</strong> deleted";
									// refresh domain array
									$content[domain] = current_domain($domain_id);
								} else {
									$content[errors][] = mysql_error();
								}
							} else {
								$content[errors][] = "Error finding the account";
							}
						} else {
							$content[errors][] = "You may not delete account id $v";
						}
					}
				} else {
					$content[errors][] = "Not enough confirmation boxes have been ticked";
				}
			} else {
				$content[errors][] = "You are not administrator for $cur_domain";
			}
		}
		/* DELETE ALIAS */
		$content[forms][del_alias][submit] = "submit_del_alias";
		$content[forms][del_alias][del_alias] = "del_alias";
		$content[forms][del_alias][del_alias_confirm] = "del_alias_confirm";
		if ($_POST[submit_del_alias]) {
			if (am_i_admin_of($domain_id)) {
				if ($_POST[del_alias] AND $_POST[del_alias_confirm]) {
					foreach ($_POST[del_alias] as $k => $v) {
						$get_alias = mysql_query("SELECT source, destination FROM view_aliases WHERE id = $v;");
						$delled_alias = mysql_fetch_assoc($get_alias);
						$deleted_alias_src = $delled_alias[source];
						$deleted_alias_dst = $delled_alias[destination];
						if (!empty($deleted_alias_src)) {
							$del_q =mysql_query("DELETE FROM `virtual_aliases` WHERE `virtual_aliases`.`id` = $v;");
							if (!mysql_error()) {
								$content[status][] = "Alias <strong>$deleted_alias_src => $deleted_alias_dst </strong> deleted";
								// refresh domain array
								$content[domain] = current_domain($domain_id);
							} else {
								$content[errors][] = mysql_error();
							}
						} else {
							$content[errors][] = "Error finding the alias";
						}
					}
				} else {
					$content[errors][] = "Not enough confirmation boxes have been ticked";
				}
			} else {
				$content[errors][] = "You are not administrator for $cur_domain";
			}
		}

		/* ADD ACCOUNT */
		$content[forms][add_account][account] = "account";
		$content[forms][add_account][password] = "password";
		$content[forms][add_account][password_verify] = "password_verify";
		$content[forms][add_account][policy] = "policy";
		$content[forms][add_account][quota] = "quota";
		$content[forms][add_account][default_quota] = $content[domain][default_quota];
		$content[forms][add_account][admin_domains] = "admin_domains";
		$content[forms][add_account][admin] = "admin";
		$content[forms][add_account][submit] = "add_account";
		$not_server_admin_addon = list_my_domains();
		$domainq = mysql_query("SELECT id, name, default_policy FROM virtual_domains $not_server_admin_addon;");
		while ($data = mysql_fetch_assoc($domainq)) {
			$list_domain_id = $data[id];
			$content[forms][add_account][domains][$list_domain_id] = $data[name];
		}
		$content[forms][add_account][policies] = $policies;
		if ($_POST[add_account]) {
			if (am_i_admin_of($domain_id)) {
				if (!empty($_POST[account])) {
					$new_account = strtolower($_POST[account]);
					if (preg_match_all("$reg_account", $new_account, $matches)) {
						$content[errors][] = "Account name contains unauthorized characters";
						$new_account = str_replace($matches[0], "", "$new_account");
					}
				} else {
					$content[errors][] = "Account name is empty";
				}
				/* double check policy & admin domains*/
				if ($_POST[policy] AND is_array($policies)) {
					if (!array_key_exists($_POST[policy], $policies) AND !empty($_POST[policy])) {
						$content[errors][] = "Bad policy id";
					}
				}
				if ($_POST[admin_domains]) {
					foreach ($_POST[admin_domains] as $k => $v) {
						if (!array_key_exists($v, $content[forms][add_account][domains])) {
							$content[errors][] = "Bad domain id";
						}
					}
				}
				/* check passwd */
				if (!empty($_POST[password]) AND !empty($_POST[password_verify])) {
					if ($_POST[password] != $_POST[password_verify]) {
						$content[errors][] = "Passwords do not match";
					}
				} else {
					$content[errors][] = "You did not enter the password twice";
				}
				if ($_POST[admin] == $content[forms][add_account][admin]) {
					if (am_i_super_admin()) {
						$admin = 1;
					} else {
						$content[errors][] = "You are not server admin";
					}
				}
				/* check quota */
				if (is_numeric($_POST[quota])) {
					$quota = $_POST[quota] * 1024;
				} else {
					$quota = $content[domain][default_quota];
					$content[status][] = "Quota reset to default: $quota MB";
					$quota = $content[domain][default_quota] * 1024;
				}
				/* insert in mysql */
				if (empty($content[errors])) {
					mysql_query("INSERT INTO `$db_database`.`virtual_users` (`id`, `domain_id`, `user`, `password`, `quota_kb`, `policy_id`, `admin`)
					VALUES (NULL, $domain_id, '$new_account', MD5('$_POST[password]'), '$quota', '$_POST[policy]', '$admin' );");
					if (!mysql_error()) {
						$new_user_id = mysql_insert_id();
						if ($_POST[admin_domains]) {
							foreach ($_POST[admin_domains] as $k => $v) {
								if (am_i_server_admin() OR $domain_id == $v) {
									mysql_query("INSERT INTO domain_admin_assoc (`domain_id`, `user_id`) VALUES ($v, $new_user_id);");
								}
							}
						}
						$content[status][] = "Account <strong>$new_account</strong> added \o/";
						// refresh domain array
						$content[domain] = current_domain($domain_id);
					} else {
						$content[errors][] = mysql_error();
					}
				} else {
					// set form values
					$content[forms][add_account][new_account] = $new_account;
					$content[status][] = "Account $new_account <strong>not</strong> added";
				}
			} else {
				$content[errors][] = "You are not administrator for $cur_domain";
			}
		}
		/* end of account form crap */

		/* ADD ALIAS */
		$content[forms][add_alias][alias_src] = "alias_src";
		$content[forms][add_alias][alias_dst] = "alias_dst";
		$content[forms][add_alias][submit] = "add_alias";
		if ($_POST[add_alias]) { // and i am domain_admin (or server_admin)
			if (am_i_admin_of($domain_id)) {
				if (!empty($_POST[alias_src])) {
					$new_alias_src = strtolower($_POST[alias_src]);
					if (preg_match_all("$reg_account", $new_alias_src, $matches)) {
						$content[errors][] = "Source contains unauthorized characters";
						$new_alias_src = str_replace($matches[0], "", "$new_alias_src");
						$content[forms][add_alias][new_alias_src] = "$new_alias_src";
					}
				} else {
					$content[errors][] = "Source is empty";
				}
				if (!empty($_POST[alias_dst])) {
					$new_alias_dst = strtolower($_POST[alias_dst]);
					if (preg_match_all("$reg_email", $new_alias_dst, $matches)) {
						$content[errors][] = "Destination contains unauthorized characters";
						$new_alias_dst = str_replace($matches[0], "", "$new_alias_dst");
						$content[forms][add_alias][new_alias_dst] = "$new_alias_dst";
					}
				} else {
					$content[errors][] = "Destination is empty";
				}
				if (empty($content[errors])) {
					mysql_query("INSERT INTO `$db_database`.`virtual_aliases` (`id`, `domain_id`, `source`, `destination`)
					VALUES (NULL, $domain_id, '$new_alias_src', '$new_alias_dst');");
					if (!mysql_error()) {
						$content[status][] = "Alias <strong>$new_alias_src => $new_alias_dst</strong> added \o/";
						// refresh domain array
						$content[domain] = current_domain($domain_id);
					} else {
						$content[errors][] = mysql_error();
					}
				} else {
					// set form values
					$content[forms][add_account][new_account] = $new_account;
					$content[status][] = "Alias $new_account <strong>not</strong> added";
				}
			} else {
				$content[errors][] = "You are not administrator for $cur_domain";
			}
		}
		/* end of add alias form */

		/* List accounts */
		$order_stuff = check_order_by('accounts');
		$content[accounts_table][th] = $order_stuff[th];
		$order_by = $order_stuff[order_by];
		$q = mysql_query("SELECT * FROM view_users WHERE domain_id = $domain_id $order_by;");
		for ($x=1; $data = mysql_fetch_assoc($q); $x++) {
			foreach ($data as $k => $v) {
				if ($k == "password") {
					unset($k);
				} elseif ($k == "admin_of_ids") {
					if (!is_null($v)) {
						$id_array = explode(",", $v);
						foreach ($id_array as $k => $v) {
							$admin_id_array[$x][] = $v;
						}
					}
				} elseif ($k == "admin_of_names") {
					if (!empty($v)) {
						$name_array = explode(",", $v);
						foreach ($name_array as $k => $v) {
							$admin_name_array[$x][] = $v;
						}
					}
				} elseif ($k == "quota_kb") {
					$content[accounts][$x][quota] = $v / 1024;
				} else {
					$content[accounts][$x][$k] = $v;
				}
			}
			if (is_array($admin_id_array[$x])) {
				$admin_of = array_combine($admin_id_array[$x], $admin_name_array[$x]);
				$content[accounts][$x][admin_of] = $admin_of;
			}
			// view admin_of stuff - if level is not ok then unset protected values
			if (!am_i_server_admin(1)) {
				unset($content[accounts][$x][admin]);
				if (is_array($content[accounts][$x][admin_of])) {
					foreach ($content[accounts][$x][admin_of] as $k => $v) {
						if (!am_i_admin_of($k)) {
							unset($content[accounts][$x][admin_of][$k]);
						}
					}
				}
			}
		}

		/* List aliases */
		$order_stuff = check_order_by('aliases');
		$content[aliases_table][th] = $order_stuff[th];
		$order_by = $order_stuff[order_by];
		$alias_q = mysql_query("SELECT * FROM view_aliases WHERE domain_id = $domain_id $order_by;");
		for ($x=1; $data = mysql_fetch_assoc($alias_q); $x++) {
			foreach ($data as $k => $v) {
				$content[aliases][$x][$k] = $v;
			}
		}

		/* List admins */
		$admin_q = mysql_query("SELECT user_id, view_users.domain_id, CONCAT(user, '@', domain) as email FROM domain_admin_assoc
		LEFT JOIN view_users ON (domain_admin_assoc.user_id = view_users.uid) WHERE domain_admin_assoc.domain_id = $domain_id;");
		$x=1;
		while ($data = mysql_fetch_assoc($admin_q)) {
			foreach ($data as $k => $v) {
				$content[admins][$x][$k] = $v;
			}
			$x++;
		}
	} else {
		$content[errors][] = "Bad domain id";
		$page = "404.php";
	}
} else {
	$content[errors][] = "You shouldn't be here";
	$page = "404.php";
}

?>
