<?php
/*
Mailboy - A Php/MySQL application that offers a web based interface
to administer an email server. It can be used by the server administrator
as well as the email users.
(c) 2009 Emmanuel Revah - manu-at-manurevah.com
http://manurevah.com/blah/en/pages/mailboy

This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>

<? /* edit domain */ ?>
<? if (am_i_admin_of($content[domain][id])) { ?>
	<fieldset>
	<legend><? echo $content[domain][name]; ?></legend>
	<form action="" method="post" enctype="multipart/form-data">
		<table>
			<tr>
				<th>Domain</th>
				<th>Amavis policy</th>
				<th>Default quota (MB)</th>
			</tr>
			<tr>
				<td><input type="text" class="input-text" name="<? echo $content[forms][mod_domain][new_domain]; ?>" value="<? echo $content[domain][name]; ?>" /></td>
				<td>
					<select name="<? echo $content[forms][mod_domain][policy]; ?>" >
						<option value="">No policy</option>
						<? foreach ($content[forms][add_account][policies] as $k => $v) { ?>
						<option value="<? echo $k; ?>" <? fill_check_input($k, "select", $content[domain][default_policy]); ?>><? echo $v; ?></option>
						<?php } ?>
					</select>
				</td>
				<td><input type="text" class="input-text" name="<? echo $content[forms][mod_domain][default_quota]; ?>" value="<? echo $content[domain][default_quota]; ?>"/></td>
			</tr>
		</table>
		<p class="submit">
			<input type="checkbox" name="<? echo $content[forms][mod_domain][mod_domain_confirm]; ?>" value="1" /><span class="pseudolabel">Are you sure ?</span>
			<input type="submit" class="input-submit" name="<? echo $content[forms][mod_domain][submit]; ?>" value="Edit" title="Please be careful here." />
		</p>
	</form>
	</fieldset>


	<? /* addmail form */ ?>
	<fieldset>
		<legend>Add account</legend>
		<form action="" method="post" enctype="multipart/form-data">
		<dl>
			<dt><label for="add_account">Account</label></dt>
			<dd><input type="text" class="input-text" name="<? echo $content[forms][add_account][account]; ?>" id="add_account" value="<? echo $content[forms][add_account][new_account]; ?>" /></dd>
			<dt><label for="password">Password</label></dt>
			<dd><input type="password" class="input-text" name="<? echo $content[forms][add_account][password]; ?>" id="password" value="" /></dd>
			<dt><label for="password_verify">Password (verify)</label></dt>
			<dd><input type="password" class="input-text" name="<? echo $content[forms][add_account][password_verify]; ?>" id="password_verify" value="" /></dd>
			<dt><label for="policy">Amavis policy</label></dt>
			<dd><select name="<? echo $content[forms][add_account][policy]; ?>" id="policy">
					<option value="">No policy</option>
					<? foreach ($content[forms][add_account][policies] as $k => $v) { ?>
					<option value="<? echo $k; ?>" <? fill_check_input($k, "select", $content[domain][default_policy]); ?>><? echo $v; ?></option>
					<?php } ?>
				</select>
			</dd>

			<dt><label for="new_account_quota">Quota (0 = no limit)</label></dt>
			<dd><input type="text" class="input-text" name="<? echo $content[forms][add_account][quota]; ?>" id="new_account_quota" value="<? echo $content[forms][add_account][default_quota]; ?>" /></dd>
			<dt><label for="domains">Administer domains</label></dt>
			<dd><select name="<? echo $content[forms][add_account][admin_domains]; ?>[]" id="domains" multiple="multiple">
					<? foreach ($content[forms][add_account][domains] as $k => $v) { ?>
					<option value="<? echo $k; ?>"><? echo $v; ?></option>
					<? } ?>
				</select>
			</dd>
			<? if(am_i_server_admin()) { ?>
			<dt><label for="global_admin">Server admin</label></dt>
			<dd><input type="checkbox" name="<? echo $content[forms][add_account][admin]; ?>" id="global_admin" value="<? echo $content[forms][add_account][admin]; ?>" /></dd>
			<? } ?>
		</dl>
		<p class="submit"><input type="submit" class="input-submit" name="<? echo $content[forms][add_account][submit]; ?>" value="Add account" /></p>
		</form>
	</fieldset>

	<? /* addalias form */ ?>
	<fieldset><legend>Add alias</legend>
		<form action="" method="post" enctype="multipart/form-data">
		<dl>
			<dt><label for="add_alias_src">Source (without domain suffix)</label></dt>
			<dd><input type="text" class="input-text" name="<? echo $content[forms][add_alias][alias_src]; ?>" id="add_alias_src" value="<? echo $content[forms][add_alias][new_alias_src]; ?>" /></dd>
			<dt><label for="add_alias_dst">Destination</label></dt>
			<dd><input type="text" class="input-text" name="<? echo $content[forms][add_alias][alias_dst]; ?>" id="add_alias_dst" value="<? echo $content[forms][add_alias][new_alias_dst]; ?>" /></dd>
		</dl>
		<p class="submit"><input type="submit" class="input-submit" name="<? echo $content[forms][add_alias][submit]; ?>" value="Add alias" /></p>
		</form>
	</fieldset>
<? } ?>

<? /* list accounts */ ?>
<? if ($content[accounts]) { ?>
	<fieldset>
	<? if (am_i_admin_of($content[domain][id])) { ?>
	<legend>Accounts</legend>
	<form action="" method="post" enctype="multipart/form-data">
	<? } else { ?>
	<legend><? echo $content[domain][name]; ?> - Accounts</legend>
	<? } ?>
		<table>
			<tr>
				<th><a href="<? echo $content[accounts_table][th][user]; ?>">user</a></th>
				<th><a href="<? echo $content[accounts_table][th][policy_name]; ?>">policy</a></th>
				<th><a href="<? echo $content[accounts_table][th][quota_kb]; ?>">quota</a></th>
				<th><a href="<? echo $content[accounts_table][th][admin_of_ids]; ?>">admin for domain</a></th>
				<th><a href="<? echo $content[accounts_table][th][admin]; ?>">server admin</a></th>
			<? if (am_i_admin_of($content[domain][id])) { ?>
				<th>delete ?</th>
			<? } ?>
			</tr>
		<? foreach ($content[accounts] as $k => $v) { ?>
			<tr>
				<td>
					<? if (am_i_admin_of($content[domain][id])) { ?>
					<a href="index.php?page=account_details&uid=<? echo $v[uid]; ?>"><? echo $v[user]; ?></a>
					<? } else { ?>
					<? echo $v[user]; ?>
					<? } ?>
				</td>
				<td><? echo $v[policy_name]; ?></td>
				<td><? echo $v[quota]; ?></td>
				<td>
			<? if ($content[accounts][$k][admin_of]) { ?>
				<ul>
				<? foreach ($content[accounts][$k][admin_of] as $k2 => $v2) { ?>
						<li><? echo $v2; ?></li>
				<?} ?>
				</ul>
			<? }?>
				</td>
				<td>
			<? if ($content[accounts][$k][admin]) { ?>
					yes
			<? } ?>
				</td>
				<? if (am_i_admin_of($content[domain][id])) { ?>
				<td>
					<input type="checkbox" name="<? echo $content[forms][del_account][del_account]; ?>[]" value="<? echo $v[uid]; ?>"/>
				</td>
				<? } ?>
			</tr>
		<? } ?>
		</table>
		<? if (am_i_admin_of($content[domain][id])) { ?>
		<p class="submit">
			<input type="checkbox" name="<? echo $content[forms][del_account][del_account_confirm]; ?>" value="1"/><span class="pseudolabel">Really do it ?</span>
			<input type="submit" class="input-submit" name="<? echo $content[forms][del_account][submit]; ?>" value="Delete" title="Please be careful here." />
		</p>
		<? } ?>
	<? if (am_i_admin_of($content[domain][id])) { ?>
	</form>
	<? } ?>
	</fieldset>
<? } else { ?>
	<p class="status">No accounts for this domain.</p>
<? } ?>

<? /* list aliases */ ?>
<? if ($content[aliases]) { ?>
<fieldset>
	<legend>Aliases</legend>
	<? if (am_i_admin_of($content[domain][id])) { ?>
	<form action="" method="post" enctype="multipart/form-data">
	<? } ?>
	<table>
		<tr>
			<th><a href="<? echo $content[aliases_table][th][source]; ?>">source</a></th>
			<th><a href="<? echo $content[aliases_table][th][destination]; ?>">destination</a></th>
		<? if (am_i_admin_of($content[domain][id])) { ?>
			<th>delete ?</th>
		<? } ?>
		</tr>
		<? foreach ($content[aliases] as $k => $v) { ?>
		<tr>
			<td>
				<? if (am_i_admin_of($content[domain][id])) { ?>
				<a href="index.php?page=account_details&alias_id=<?echo $v[id]; ?>">
				<? } ?>
				<? echo $v[email]; ?>
				<? if (am_i_admin_of($content[domain][id])) { ?>
				</a>
				<? } ?>
			</td>
			<td><? echo $v[destination]; ?></td>
			<? if (am_i_admin_of($content[domain][id])) { ?>
			<td>
				<input type="checkbox" name="<? echo $content[forms][del_alias][del_alias]; ?>[]" value="<? echo $v[id]; ?>"/>
			</td>
			<? } ?>
		</tr>
		<? } ?>
	</table>
	<? if (am_i_admin_of($content[domain][id])) { ?>
	<p class="submit">
		<input type="checkbox" name="<? echo $content[forms][del_alias][del_alias_confirm]; ?>" value="1" /><span class="pseudolabel">Really do it ?</span>
		<input type="submit" class="input-submit" name="<? echo $content[forms][del_alias][submit]; ?>" value="Delete" title="Please be careful here." />
	</p>
	</form>
	<? } ?>
</fieldset>
<? } ?>

<? /* list admins */
if ($content[admins]) { ?>
<fieldset>
	<legend>Domain admins</legend>
	<ul>
		<? foreach ($content[admins] as $k => $v) { ?>
		<li>
			<? if (am_i_admin_of($content[admins][$k][domain_id])) { ?>
			<a href="index.php?page=account_details&uid=<? echo $content[admins][$k][user_id]; ?>">
			<? } ?>
			<? echo $content[admins][$k][email]; ?>
			<? if (am_i_admin_of($content[admins][$k][domain_id])) { ?>
			</a>
			<? } ?>
		</li>
		<? } ?>
	</ul>
</fieldset>
<? } ?>
